#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QSplitter>
#include <QSpinBox>
#include <QPushButton>
#include <QFileDialog>
#include <QApplication>
#include <QTableWidgetItem>
#include <QEvent>
#include <QBoxLayout>
#include <QLabel>
#include <QMessageBox>
#include <QHeaderView>
#include <QMenuBar>
#include <QStatusBar>
#include <QMainWindow>
#include <QLineEdit>
#include <QPropertyAnimation>

class CustomTableWidget;

QT_BEGIN_NAMESPACE
class QAction;
class QActionGroup;
class QLabel;
class QMenu;
QT_END_NAMESPACE

class QContextMenuEvent;

void GetValueDialog();
void SetValueDialog();

class MainWindow : public QMainWindow
{
    Q_OBJECT
public:
    MainWindow();
    void change(QTableWidgetItem* item, char val=2);
    void change(char,char,char val=2);
    
protected:
#ifndef QT_NO_CONTEXTMENU
    void contextMenuEvent(QContextMenuEvent *event) override;
#endif // QT_NO_CONTEXTMENU
    
private slots:
    void newFile();
    bool open();
    void save();
    void about();
    void fill();
    void clear();
    void createTable(int n);
    void handleSubmit();
private:
    QMenu *fileMenu;
    QMenu *tableMenu;
    QMenu *helpMenu;
    QActionGroup *alignmentGroup;
    QAction *newAct;
    QAction *openAct;
    QAction *saveAct;
    QAction *exitAct;
    QAction *getAct;
    QAction *setAct;
    QAction *clearAct;
    QAction *fillAct;
    QAction *aboutAct;
    QAction *aboutQtAct;
    QLabel *infoLabel;
    CustomTableWidget *tableWidget;
    QSplitter *splitter;
    QPushButton *submitButton;
    QPushButton *setButton;
    QPushButton *getButton;
    QSpinBox *spinBox;
    char size;
    QSpinBox *coordEditX;
    QSpinBox *coordEditY;
    QSpinBox *valueEdit;
    QLabel *valueLabel;
    QLabel *coordLabelY;
    QLabel *coordLabelX;
    void setElement();
    void getElement();
    void set();
    void get();
    void openGetValueDialog();
    void openSetValueDialog();
};

#endif // MAINWINDOW_H
